﻿//接口协议代码
;(function () {
    var api = {
        commandQueue:[],
        cmdQueue : {},
        index:0,
        mNativeFunction:{}
    };
    var protocol = "beacon";

    api.os = function(){
        var ua = navigator.userAgent;
        var ipad = ua.match(/(iPad).*OS\s([\d_]+)/);
        var iphone = !ipad && ua.match(/(iPhone\sOS)\s([\d_]+)/);
        var os = {};
        if (iphone) os.ios = os.iphone = true;
        if (ipad) os.ios = os.ipad = true;
        return {ios:os.ios};
    };

    api.getCookie = function(name) {
        var regexp = new RegExp("(?:^" + name + "|;\\s*" + name + ")=(.*?)(?:;|$)", "g");
        var result = regexp.exec(document.cookie);
        return (result === null) ? null : unescape(result[1]);
    };

    api.exec = function(cmd,option,callback){
        api.index+=1;
        var callbackId = new Date().getTime()+"|"+api.index;
        option = option||{};
        api.cmdQueue[callbackId] = callback;
        var nativeOption = {
            callbackId:callbackId,
            option:option
        };

        var apiContent =  protocol+"://["+cmd+"-"+JSON.stringify(nativeOption)+"]";
        prompt(protocol,apiContent);
    };

    window.AppCallback = function(callbackId,option){
        if(api.cmdQueue[callbackId])
        {
            api.cmdQueue[callbackId](option);
        }
    };

    window[protocol+"Api"] = api;

    //客户端预埋接口
    window.ReqWeb = function (key, value) {
        if(api.mNativeFunction[key] != undefined ){
            api.mNativeFunction[key](value);
        }
    };

    //监听native
    window.lisenNative = function (key, func) {
        api.mNativeFunction[key] = func;
    };
})();

(function(){
    var beacon = {};
    //判断请求是否走代理
    beacon.sendData = function(option,callBack){
        beaconApi.exec("sendData",option,function(data){
            callBack(data);
        });
    };

    beacon.notifyClick = function(option,callBack){
        beaconApi.exec("notifyClick",option,function(data){
            callBack(data);
        });
    };

    beacon.isHaveProxy = function(option,callBack){
        if(typeof NativeProxy != "undefined"){
            callBack(NativeProxy.isHaveProxy());
        }else{
            beaconApi.exec("isHaveProxy",option,function(data){
                callBack(data);
            });
        }
    };

    beacon.saveAccountInfo = function(option,callBack){
        beaconApi.exec("saveAccountInfo",option,function(data){
            callBack(data);
        });
    };

    beacon.notifyLogginError = function(option,callBack){
        beaconApi.exec("notifyLogginError",option,function(data){
            callBack(data);
        });
    };
    window.beacon = beacon;
})();

$.extend($, {
    //jq模板
    compiler: function (str, data){
        var compiler = arguments.callee;
        //如果参数str全部为组词字符
        //console.log /^\w*$/.test(str), "xxx"
        var fn;
        if(/^\w*$/.test(str)){
            fn = !compiler[str] && (compiler[str] = compiler(document.getElementById(str).innerHTML));
        }else{
            fn = new Function("obj", "var p=[];with(obj){p.push('" +
                str.replace(/[\r\t\n]/g, " ")
                    .split("<@").join("\t")
                    .replace(/((^|@>)[^\t]*)'/g, "$1\r")
                    .replace(/\t=(.*?)@>/g, "',$1,'")
                    .split("\t").join("');")
                    .split("@>").join("p.push('")
                    .split("\r").join("\\'")+ "');}return p.join('');");
        }
        return data ? fn(data) : fn;
    },
    getQueryString:function (name, fullString) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
        if(fullString==undefined){
            var r = window.location.search.substr(1).match(reg);
        }else{
            var r = fullString.match(reg);
        }
        // $.mobileConsole(r);
        if (r != null){
            var value = r[2];
            value = value.replace(/(%22|%3E|%3C|<|>)/g, "MM");
            if(value==''){ //此处为安卓下浏览器的一个坑，匹配正则有区别
                return null;
            }else{
                return decodeURIComponent(value);
            }
        }else{
            return null;
        }
    },
    mobileConsole:function(content){
        var consoleContent='',
            mobileConsoleStyle='<style>	#mobileConsole{position: fixed; z-index: 9999991000; right: 0; top: 0; width: 60%; height: 50%; background-color: rgba(0,0,0,0.6); overflow: auto; color: #fff; font-size: 12px; word-break:break-all; padding: 5px 0; border-radius: 0 0 0 10px; font-family: "Microsoft Yahei",SimHei,"Helvetica Neue","DejaVu Sans",Tahoma; pointer-events:none; } #mobileConsole p{ padding: 4px 10px; margin: 0; border-bottom: 1px rgba(255,255,255,.1) solid;} </style>';

        function isJson(obj){
            var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
            return isjson;
        }
        //创建dom结构和样式
        if( $('#mobileConsole').length==0 ){
            $('body').append('<div id="mobileConsole"></div>');
            $('body').append(mobileConsoleStyle);
        }
        //如果为json对象，则字符串化
        consoleContent=content;
        if(isJson(content)){
            consoleContent=JSON.stringify(content);
        }
        //填入数据
        $('#mobileConsole').prepend('<p>'+consoleContent+'</p>');
    },
    getData:function(options){
        var settings={
            type: 'get',
            timeout:10000,
            // timeout:10,
            dataType:"json",
            error:function(){
                $.alert('网络异常，请稍后重试！',3000);
            }
        };
        $.extend(settings,options);
        var getAjaxData = "";
        (function(settings){
            var ajaxTimes = 0;//重试次数
            getAjaxData = function(){
                $.ajax({
                    type: settings.type,
                    url: settings.url,
                    data : settings.data,
                    dataType:settings.dataType,
                    timeout:settings.timeout,
                    success: function(data){
                        if(data.ret != -1){
                            settings.success(data);
                        }else{
                            if(ajaxTimes<0){
                                ajaxTimes++;
                                setTimeout(function(){
                                    getAjaxData();
                                },1000);
                            }else{
                                settings.error();
                            }
                        }
                    },
                    error:function(){
                        if(ajaxTimes<0){
                            ajaxTimes++;
                            setTimeout(function(){
                                getAjaxData();
                            },1000);
                        }else{
                            //$.alert('网络异常，请稍后重试！',3000);
                            settings.error();
                        }
                    }
                })
            }
            getAjaxData();
        })(settings)
    },
    getAjaxHost:function(type){  //news,common,newsHref,commonHref,commonHrefHttp
        var nowUrl = location.href;
        var protocol = location.protocol;
        if(nowUrl.indexOf("192.168")!=-1){
            if(type == "news"){
                // return "http://59.172.4.154:55551/";
                 return "http://news.wedengta.com/";
            }else if(type == "common"){
                // return "http://59.172.4.154:55553/";
                 return "http://sec.wedengta.com/";
            }else if(type == "newsHref"){
                return "http://"+location.host+"/";
            }else if(type == "commonHref" || type == "commonHrefHttp"){
                return "http://"+location.host+"/";
            }else{
                return "http://node.dengtacj.cn:55561/";
            }
        }else if(nowUrl.indexOf("dengtacj")!=-1||nowUrl.indexOf("59.172.4.154")!=-1){
            if(type == "news"){
                return "http://59.172.4.154:55551/";
                // return "http://news.wedengta.com/";
            }else if(type == "common"){
                return "http://59.172.4.154:55553/";
                // return "http://sec.wedengta.com/";
            }else if(type == "newsHref"){
                return "http://node.dengtacj.cn:55561/";
            }else if(type == "commonHref"){
                return "http://node.dengtacj.cn:55561/";
            }else{
                return "http://node.dengtacj.cn:55561/";
            }
        }else if(nowUrl.indexOf("wedengta")!=-1){
            if(type == "news"){
                return protocol+"//news.wedengta.com/";
            }else if(type == "common"){
                return protocol+"//sec.wedengta.com/";
            }else if(type == "newsHref"){
                return protocol+"//news.wedengta.com/";
            }else if(type == "commonHref"){
                return protocol+"//sec.wedengta.com/";
            }else if(type == "commonHrefHttp"){
                return "http://sec.wedengta.com/";
            }else{
                return protocol+"//sec.wedengta.com/";
            }
        }else if(nowUrl.indexOf("dengtacjw")!=-1){
            if(type == "news"){
                return protocol+"//news.dengtacjw.cn/";
            }else if(type == "common"){
                return protocol+"//sec.dengtacjw.cn/";
            }else if(type == "newsHref"){
                return protocol+"//news.dengtacjw.cn/";
            }else if(type == "commonHref"){
                return protocol+"//sec.dengtacjw.cn/";
            }else if(type == "commonHrefHttp"){
                return "http://sec.dengtacjw.com/";
            }else{
                return protocol+"//sec.dengtacjw.cn/";
            }
        }else{
            if(protocol == "file:"){
                if(type == "news"){
                    return "http://news.wedengta.com/";
                }else if(type == "common"){
                    return "http://sec.wedengta.com/";
                }else if(type == "newsHref"){
                    return "http://news.wedengta.com/";
                }else if(type == "commonHref"){
                    return "http://sec.wedengta.com/";
                }else if(type == "commonHrefHttp"){
                    return "http://sec.wedengta.com/";
                }else{
                    return "http://sec.wedengta.com/";
                }
            }
        }
    },
    /**
     *var testDate = new Date( 1320336000000 );//这里必须是整数，毫秒
     *var testStr = testDate.format("yyyy年MM月dd日hh小时mm分ss秒");
     *var testStr2 = testDate.format("yyyyMMdd hh:mm:ss");
     */
    dateConverter:function(formatData, timestamp){
        Date.prototype.format = function(format){
            var o =
            {
                "M+" : this.getMonth()+1, //month
                "d+" : this.getDate(), //day
                "h+" : this.getHours(), //hour
                "m+" : this.getMinutes(), //minute
                "s+" : this.getSeconds(), //second
                "q+" : Math.floor((this.getMonth()+3)/3), //quarter
                "S" : this.getMilliseconds() //millisecond
            }

            if(/(y+)/.test(format))
            {
                format = format.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
            }

            for(var k in o)
            {
                if(new RegExp("("+ k +")").test(format))
                {
                    format = format.replace(RegExp.$1, RegExp.$1.length==1 ? o[k] : ("00"+ o[k]).substr((""+ o[k]).length));
                }
            }
            return format;
        }
        var timeFormat = new Date(timestamp);
        return timeFormat.format(formatData);
    }
});