/**
 * Created by kevenfeng on 2016/3/29.
 */
var news = {
    type : '',
    id : '',
    channel : '',
    serverUrl : $.getAjaxHost("news"),
    canShowLoading:true,
    newsInfo:"",
    init:function(){
        var that=this;
        if($.getQueryString("id")==undefined){
            //
        }else{
            that.id = $.getQueryString("id");
            that.type = $.getQueryString("type");
            that.channel = $.getQueryString("channel");
            that.getNewsInfoAndShow();
        }
        this.addEvent();
        this.addNativeEvent();
        setTimeout(function(){
            if(that.canShowLoading){
                $('#bigLoading').removeClass('none');
            }
        },200);

        this.setHtmlStyle();
    },
    setHtmlStyle:function(){
        var viewportWidth= document.documentElement.clientWidth;
        if(viewportWidth<=1700){
            $('html').attr({
                style:'font-size:9px'
            })
        }
        if(viewportWidth<=1400){
            $('html').attr({
                style:'font-size:8.6px'
            })
        }
        if(viewportWidth<=1200){
            $('html').attr({
                style:'font-size:8.3px'
            })
        }
        if(viewportWidth<=1020){
            $('html').attr({
                style:'font-size:7.1px'
            })
        }
        if(viewportWidth<=900){
            $('html').attr({
                style:'font-size:5.9px'
            })
        }
        if(viewportWidth<=780){
            $('html').attr({
                style:'font-size:5.8px'
            })
        }
        if(viewportWidth<=560){
            $('html').attr({
                style:'font-size:4.4px'
            })
        }

    },
    addEvent:function(){
        var that =this;
        //按ok键时，把视频id传给终端
        $("body").on("keydown", function(e) {
            var videoId = $('.video_poster').attr('data-id');
            //if(videoId==null&&that.newsInfo==""){return;}  //如果没有id就不做动作
            var keyCode = e.keyCode || e.which;
            if (keyCode == 13) {
                var option={
                    id:videoId
                }
                beacon.notifyClick(JSON.stringify(option),function(){
                });
            }
        });
    },
    addNativeEvent:function(){
        var that = this;
        //在url不带参数时，通过传给我的参数
        lisenNative('inputParam', function(data_path) {
            // var data_path='id=1462261393_515597432290_104_5&type=2';
            var id=$.getQueryString("id",data_path);
            var type=$.getQueryString("type",data_path);
            var channel=$.getQueryString("channel",data_path);

            news.id = id;
            news.type = type;
            news.channel = channel;
            news.getNewsInfoAndShow();
        });

        //tv进到页面时，video图片获得焦点
        lisenNative('setFocus', function(isFoucs) {
            if(isFoucs){
                $('.video_img').addClass('active');
            }else{
                $('.video_img').removeClass('active');
            }
        });

        lisenNative('ajaxSuccess', function(data) {//tv上面 前端ajax请求可能会被代理，代理以后ajax没法正确返回数据，所以通过终端接口的形式返回数据
            that.getNewsInfoSuccess(data.data);
        });

        lisenNative('ajaxError', function(data) {
            that.getStockLiveInfoAjaxError(data.data);
        });
    },
    getNewsInfoAndShow:function(){
        if(this.type== 4){//发现页面的资讯
            var action = "DiscNewsContent";
        }else{
            var action = "Content";
        }

        var that = this;
        var options = {
            url:this.serverUrl+'getNews',
            data:{
                action:action,
                type:this.type,
                channel:this.channel,
                id:this.id
            },
            success:function(data){
                that.getNewsInfoSuccess(data);
            },
            error:function(data){
                try {
                    beacon.isHaveProxy(JSON.stringify({}), function (result) {
                        if (!result.isHaveProxy) {
                            that.getNewsInfoError(data);
                        }
                    });
                }catch(e){
                    that.getNewsInfoError(data);
                }
            }
        };

        $.getData(options);
    },
    getNewsInfoSuccess:function(data){
        this.canShowLoading=false;
        $('#bigLoading').addClass('none');
        if(data.ret!=0||data.content == ""){
            $('#noData').removeClass("none");
            return;
        }
        $('#content').removeClass('none');

        //ret -2时表示文章已删除
        if(data.ret == -2){
            $('#newsDeleted').removeClass("none");
            return;
        }
        
        var newsData = JSON.parse(data.content);

        //不是目前版本里有的类型时提示升级
        var newsTypeArray=[0,1,2,3,4,5,6,7,8,9,10,11];
        var newsFlagArray=[0,1,2,3,4];
        if(newsTypeArray.indexOf(newsData.eNewsType)==-1 || newsFlagArray.indexOf(newsData.eNewsFlag)==-1){
            $('#upgradeToView').removeClass("none");
            return;
        }

        var url = "";
        if(newsData.sThirdUrl!=undefined){
            url=encodeURI(newsData.sThirdUrl);
        }
        if(url!='' && newsData.sContent==''){        //如果只有pdf
            $('#downloadCode').removeClass("none");
        }

        //处理态度标签
        if(newsData.vtTagInfo.length!=0 && newsData.vtTagInfo[0].eAttiType>0 && newsData.vtTagInfo[0].eAttiType<6){
            var attitude=6-newsData.vtTagInfo[0].eAttiType/1;
            $("#newsTag").removeClass('none');
            $("#newsTag li").eq(attitude-1).addClass('on');
            $("#newsTag li").eq(attitude-1).find('span').html(newsData.vtTagInfo[0].sTagName);
        }

        newsData.sTitle=newsData.sTitle.replace(/【数据日报】/g,'');
        // console.log(newsData.sTitle)
        $("#newsTitle").html(newsData.sTitle);
        if(this.type!=3){
            $("#newsAuthor").html(newsData.sFrom);
        }
        var tempDate=$.dateConverter("yyyy-MM-dd hh:mm",newsData.iTime*1000);

        if(tempDate.substr(11,5)=='00:00'){
            tempDate=tempDate.substr(0,11);
        }
        $("#newsDate").html(tempDate);

        $("#newsContent").html(newsData.sContent);

        //处理摘要
        if(newsData.sDescription!=''){
            $('#summary').removeClass('none').html(newsData.sDescription);
        }

        var videoId = $('.video_poster').attr('data-id');
        if(videoId==null){//如果有视频id 就不传新闻内容  海波说确定是互斥的
            //告诉tv终端新闻内容 tts使用
            var options = {
                "type":"newsInfo",
                "data":newsData
            }
        }else{
            var options = {
                "type":"video",
                "data":{"videoId":videoId}
            }
        }
        beacon.sendData(JSON.stringify(options),function(){});
        //try {
        //    NativeProxy.sendData(JSON.stringify(options));
        //}catch (e){}

    },
    getNewsInfoError:function(data){
        this.canShowLoading=false;
        $('#noData').removeClass("none").html('内容无法显示，请稍后重试');
        $('#bigLoading').addClass('none');
        return;
    },
    mobileConsole:function(content){
        var consoleContent='',
            mobileConsoleStyle='<style> #mobileConsole{position: fixed; z-index: 9999991000; right: 0; top: 0; width: 60%; height: 50%; background-color: rgba(0,0,0,0.6); overflow: auto; color: #fff; font-size: 12px; word-break:break-all; padding: 5px 0; border-radius: 0 0 0 10px; font-family: "Microsoft Yahei",SimHei,"Helvetica Neue","DejaVu Sans",Tahoma; pointer-events:none; } #mobileConsole p{ padding: 4px 10px; margin: 0; border-bottom: 1px rgba(255,255,255,.1) solid;} </style>';

        function isJson(obj){
            var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
            return isjson;
        }
        //创建dom结构和样式
        if( $('#mobileConsole').length==0 ){
            $('body').append('<div id="mobileConsole"></div>');
            $('body').append(mobileConsoleStyle);
        }
        //如果为json对象，则字符串化
        consoleContent=content;
        if(isJson(content)){
            consoleContent=JSON.stringify(content);
        }
        //填入数据
        $('#mobileConsole').prepend('<p>'+consoleContent+'</p>');
    }
}
news.init();

// locationTo();

// $.mobileConsole($(window).width(), $(window).height());


