/**
 * Created by kevenfeng on 2016/3/29.
 */
var stockLive = {
    canShowLoading: true,
    secCode: '',
    secName: '',
    init: function() {
        var that = this;
        if ($.getQueryString("secName") == undefined) {
            //
        } else {
            this.secCode = $.getQueryString("secCode");
            this.secName = $.getQueryString("secName").replace(/\+/g, ' ');
            $("#secName").html(this.secName +'(<b>'+this.secCode.substr(4,10)+'</b>)  <i class="ico_line"></i> 个股直播');
            this.createPage();
        }


        $("#stockLiveExp").focus();
        setTimeout(function() {
            $("#liveList").focus();
        }, 300);
        this.addEvent();
        this.addNativeEvent();
        setTimeout(function() {
            if (that.canShowLoading) {
                $('#bigLoading').removeClass('none');
            }
        }, 300);
    },
    addNativeEvent: function() {
        var that = this;
        //在url不带参数时，通过传给我的参数  tv 4.0系统url带不上参数，所以通过接口传参
        lisenNative('inputParam', function(data_path) {
            // var data_path='seccode=0001002340&secname=格林美';
            // console.log(data_path);
            var seccode = $.getQueryString('seccode', data_path);
            var secname = $.getQueryString('secname', data_path).replace(/\+/g, ' ');
            // mobileConsole(seccode);
            // mobileConsole(secname);
            that.secCode = seccode;
            that.secName = secname;
            $("#secName").html('个股直播 <i class="ico_line"></i> ' + secname);
            that.createPage();
        });

        lisenNative('ajaxSuccess', function(data) { //tv上面 前端ajax请求可能会被代理，代理以后ajax没法正确返回数据，所以通过终端接口的形式返回数据
            that.getStockLiveInfoAjaxSuccess(data.data);
        });

        lisenNative('ajaxError', function(data) {
            that.getStockLiveInfoAjaxError(data.data);
        });
    },
    mobileConsole: function(content) {
        var consoleContent = '',
            mobileConsoleStyle = '<style> #mobileConsole{position: fixed; z-index: 9999991000; right: 0; top: 0; width: 60%; height: 50%; background-color: rgba(0,0,0,0.6); overflow: auto; color: #fff; font-size: 12px; word-break:break-all; padding: 5px 0; border-radius: 0 0 0 10px; font-family: "Microsoft Yahei",SimHei,"Helvetica Neue","DejaVu Sans",Tahoma; pointer-events:none; } #mobileConsole p{ padding: 4px 10px; margin: 0; border-bottom: 1px rgba(255,255,255,.1) solid;} </style>';

        function isJson(obj) {
            var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
            return isjson;
        }
        //创建dom结构和样式
        if ($('#mobileConsole').length == 0) {
            $('body').append('<div id="mobileConsole"></div>');
            $('body').append(mobileConsoleStyle);
        }
        //如果为json对象，则字符串化
        consoleContent = content;
        if (isJson(content)) {
            consoleContent = JSON.stringify(content);
        }
        //填入数据
        $('#mobileConsole').prepend('<p>' + consoleContent + '</p>');
    },
    createPage: function() {
        var that = this;
        var options = {
            url: $.getAjaxHost("common") + 'getMarketQuotation',
            data: {
                action: 'largeunit',
                seccode: this.secCode
            },
            success: function(data) {
                that.getStockLiveInfoAjaxSuccess(data);
            },
            error: function(data) {
                try {
                    beacon.isHaveProxy(JSON.stringify({}), function(result) {
                        if (!result.isHaveProxy) {
                            that.getStockLiveInfoAjaxError(data);
                        }
                    });
                } catch (e) {
                    that.getStockLiveInfoAjaxError(data);
                }
            }
        };
        $.getData(options);
    },
    getStockLiveInfoAjaxSuccess: function(data) {
        this.canShowLoading = false;
        $('#bigLoading').addClass("none");
        if (data.content == "") {
            $("#liveList").html('<div id="noData" class="display_center">\
                    <div class="no_data">暂无直播内容</div>\
                </div>');
            $("#todayDate").addClass('none');
        } else {
            if (JSON.parse(data.content).vLargeUnitDesc.length == 0) {
                $("#liveList").html('<div id="noData" class="display_center">\
                        <div class="no_data">暂无直播内容</div>\
                    </div>');
                $("#todayDate").addClass('none');
            } else {
                var listData = this.dataFormat(JSON.parse(data.content).vLargeUnitDesc).reverse();
                var template = $("#listTmplete").html();
                var compiledHTML = $.compiler(template, { data: listData });
                $("#liveList .live_list").html(compiledHTML);

                $("#todayDate").removeClass('none').html($.dateConverter('yyyy-MM-dd', JSON.parse(data.content).vLargeUnitDesc[0].iTime * 1000));

            }
        }
    },
    getStockLiveInfoAjaxError: function(data) {
        this.canShowLoading = false;
        $('#bigLoading').addClass("none");

        $("#liveList").html('<div id="noData" class="display_center">\
                <div class="no_data">内容无法显示，请稍后重试</div>\
            </div>');
    },
    createRateAndCountDom:function (rate){
        var rate = rate.toFixed(2);
        if(rate>0){
            var rateDom = '+'+rate+'%';
        }else if(rate<0){
            var rateDom = ''+rate+'%';
        }else{
            var rateDom = ""+rate+"%";
        }
        return rateDom;

    },
    dataFormat: function(data) {
        var that=this;
        var tempData = [];
        for (var i = 0; i < data.length; i++) {
            data[i].time = $.dateConverter('hh:mm', data[i].iTime * 1000);
            // console.log(data[i]);
            if (data[i].lSuperBuy != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_good",
                    title: "顶级委托买单",
                    desc: "顶级委托买单" + data[i].lSuperBuy + "手"
                });
            }
            if (data[i].lSuperSell != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_bad",
                    title: "顶级委托卖单",
                    desc: "顶级委托卖单" + data[i].lSuperSell + "手"
                });
            }
            if (data[i].lSuperLargeBuy != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_good",
                    title: "超大委托买单",
                    desc: "超大委托买单" + data[i].lSuperLargeBuy + "手"
                });
            }
            if (data[i].lSuperLargeSell != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_bad",
                    title: "超大委托卖单",
                    desc: "超大委托卖单" + data[i].lSuperLargeSell + "手"
                });
            }
            if (data[i].lLargeBuy != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_good",
                    title: "大笔成交买入",
                    desc: "大笔买入成交" + (data[i].lLargeBuy * data[i].fNow / 100).toFixed(1) + "万元，价格" + data[i].fNow + "元"
                });
            }
            if (data[i].lLargeSell != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_bad",
                    title: "大笔成交卖出",
                    desc: "大笔卖出成交" + (data[i].lLargeSell * data[i].fNow / 100).toFixed(1) + "万元，价格" + data[i].fNow + "元"
                });
            }
            if (data[i].lCancelBuy != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_bad",
                    title: "大笔撤买单",
                    desc: "大笔撤买单" + data[i].lCancelBuy + "手"
                });
            }
            if (data[i].lCancelSell != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "li_good",
                    title: "大笔撤卖单",
                    desc: "大笔撤卖单" + data[i].lCancelSell + "手"
                });
            }
            if (data[i].lPostLargeBuy != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "",
                    title: "大买盘",
                    desc: "五档买盘共计" + data[i].lPostLargeBuy + "手"
                });
            }
            if (data[i].lPostLargeSell != 0) {
                tempData.push({
                    time: data[i].time,
                    class: "",
                    title: "大卖盘",
                    desc: "五档卖盘共计" + data[i].lPostLargeSell + "手"
                });
            }

            if(data[i].ePanKouType==undefined){
                return;
            }

            if(data[i].ePanKouType==2){
                var changeRate = (data[i].fNow-data[i].fClose)/data[i].fClose*100;
                if(changeRate>9.9) {
                    tempData.push({
                        time: data[i].time,
                        class: "li_good",
                        title: "封涨停板",
                        desc: "封涨停板 最新价" + data[i].fNow.toFixed(2) + "元（" + that.createRateAndCountDom(changeRate) + "）"
                    });
                }
            }
            if(data[i].ePanKouType==3){
                var changeRate = (data[i].fNow-data[i].fClose)/data[i].fClose*100;
                if(changeRate<-9.9) {
                    tempData.push({
                        time: data[i].time,
                        class: "li_bad",
                        title: "封跌停板",
                        desc: "封跌停板 最新价" + data[i].fNow.toFixed(2) + "元（" + that.createRateAndCountDom(changeRate) + "）"
                    });
                }
            }
            if(data[i].ePanKouType==4){
                var changeRate = (data[i].fNow-data[i].fClose)/data[i].fClose*100;
                tempData.push({
                    time: data[i].time,
                    class: "",
                    title: "打开涨停板",
                    desc: "打开涨停板 最新价" + data[i].fNow.toFixed(2) + "元（" + that.createRateAndCountDom(changeRate) + "）"
                });
            }
            if(data[i].ePanKouType==5){
                var changeRate = (data[i].fNow-data[i].fClose)/data[i].fClose*100;
                tempData.push({
                    time: data[i].time,
                    class: "",
                    title: "打开跌停板",
                    desc: "打开跌停板 最新价" + data[i].fNow.toFixed(2) + "元（" + that.createRateAndCountDom(changeRate) + "）"
                });
            }
            if(data[i].ePanKouType==25){
                var changeRate = (data[i].fNow-data[i].fClose)/data[i].fClose*100;
                tempData.push({
                    time: data[i].time,
                    class: "li_bad",
                    title: "快速下跌",
                    desc: "快速下跌 最新价" + data[i].fNow.toFixed(2) + "元（" + that.createRateAndCountDom(changeRate) + "）"
                });
            }
            if(data[i].ePanKouType==22){
                var changeRate = (data[i].fNow-data[i].fClose)/data[i].fClose*100;
                tempData.push({
                    time: data[i].time,
                    class: "li_good",
                    title: "快速拉升",
                    desc: "快速拉升 最新价" + data[i].fNow.toFixed(2) + "元（" + that.createRateAndCountDom(changeRate) + "）"
                });

            }
            if(data[i].ePanKouType==16){
                if(data[i].lFenDan!=0){
                    tempData.push({
                        time:data[i].time,
                        class:"li_good",
                        title:"拖拉机买单",
                        desc:"拖拉机买单"+data[i].lFenDan+"手"
                    });
                }
            }
            if(data[i].ePanKouType==17){
                if(data[i].lFenDan!=0){
                    tempData.push({
                        time:data[i].time,
                        class:"li_bad",
                        title:"拖拉机卖单",
                        desc:"拖拉机卖单"+data[i].lFenDan+"手"
                    });
                }
            }
        };
        return tempData;
    },
    addEvent: function() {
        $("#liveList").on("keydown", function(e) {
            //32    Space（空格键）
            //37    Left（左箭头）
            //38    Up（上箭头）
            //39    Right（右箭头）
            //40    Down（下箭头）
            var keyCode = e.keyCode || e.which;
            // alert(keyCode);
            switch (keyCode) {
                case 38:
                    if ($(this).scrollTop() == 0) {
                        $("#stockLiveExp").focus();
                    } else {
                        e.preventDefault();
                        var scrollTopValue = $(this).scrollTop() - 20;
                        $(this).scrollTop(scrollTopValue)
                    }
                    break;
                case 39:
                    $("#stockLiveExp").focus();
                    break;
                case 40:
                    e.preventDefault();
                    var scrollTopValue = $(this).scrollTop() + 20;
                    $(this).scrollTop(scrollTopValue)
                    break;
            }
        });
        $("#stockLiveExp").on("keydown", function(e) {
            var keyCode = e.keyCode || e.which;
            switch (keyCode) {
                case 37:
                case 40:
                    $("#liveList").focus();
                    break;
            }
        });
    },
    alert: function(tips, times) {
        if (times == undefined) {
            var optTimes = 2000;
        } else {
            var optTimes = times;
        }

        if (!$("#util-pop-alert").length) {

            $("body").append('<div id="util-pop-alert" class="pop_alert"></div>')

            $("#util-pop-alert").css({
                position: 'fixed',
                left: '50%',
                bottom: '40px',
                background: 'rgba(89,89,89,.9)',
                color: '#fff',
                padding: '10px',
                opacity: '0',
                'text-align': 'center',
                '-webkit-transform': 'translate(-50%,0)',
                'transform': 'translate(-50%,0)',
                'z-index': '2000',
                'width': '78%',
                'border-radius': '6px',
                'line-height': '1.5',
                'word-break': 'break-all',
                'font-size': '16px',
                '-webkit-transition': 'all .3s ease-in'
            }).on('tap', function() {
                $("#util-pop-alert").css({ opacity: '0' });
            });
        }

        setTimeout(function() {
            $("#util-pop-alert").html(tips).css({ opacity: '1' });
        }, 0);

        setTimeout(function() {
            $("#util-pop-alert").css({ opacity: '0' });
        }, optTimes);
    }
}
stockLive.init();

// locationTo();

// common.mobileConsole($(window).width(), $(window).height());

//http://192.168.9.32:3000/stockLive.html?secName=%E4%B8%8A%E6%B5%B7%E6%96%B0%E9%98%B3&secCode=0001300236
